// Generated by CoffeeScript 1.8.0
(function() {
  var WeixinTools, assert, debuglog;

  debuglog = require("debug")("weixin_tools");

  assert = require("assert");


  /*
   * 微信的工具类
   */

  WeixinTools = (function() {
    function WeixinTools(options) {
      debuglog("LOG [weixin_tools::constructor] start");
      this.appid = options.appid;
      this.secret = options.secret;
      this.isDebug = options.isDebug || false;
      this.jsApiList = options.jsApiList || [];
      assert(this.appid, "missing weixin appid");
      assert(this.secret, "missing weixin secret");
      this.payOptions = options.payOptions;
      assert(this.payOptions, "missing weixin payOptions");
      this.payOptions.passphrase = this.payOptions.passphrase || this.payOptions.mchId;
      this.originalID = options.originalID;
      this.mixins();
      return;
    }

    WeixinTools.prototype.mixins = function() {
      this.mixin(require("./models/token"));
      this.mixin(require("./models/signature"));
      this.mixin(require("./models/menus"));
      this.mixin(require("./models/oauth"));
      this.mixin(require("./models/pay"));
      this.mixin(require("./models/message"));
      this.mixin(require("./models/receive"));
      this.mixin(require("./models/material"));
    };

    WeixinTools.prototype.mixin = function(obj) {
      var key, v;
      for (key in obj) {
        v = obj[key];
        this[key] = v;
      }
    };

    WeixinTools.prototype.generateNonceStr = function() {
      return Math.random().toString(36).substr(2, 15);
    };

    WeixinTools.prototype.generateTimestamp = function() {
      return parseInt(Date.now() / 1000);
    };

    WeixinTools.prototype.generateConfig = function(url, jsapi_ticket) {
      var args, noncestr, result, sign, timestamp;
      noncestr = this.generateNonceStr();
      timestamp = this.generateTimestamp();
      args = {
        url: url,
        jsapi_ticket: jsapi_ticket,
        noncestr: noncestr,
        timestamp: timestamp
      };
      sign = this.makeSignature(args);
      result = {
        debug: this.isDebug,
        appId: this.appid,
        jsapi_ticket: jsapi_ticket,
        nonceStr: noncestr,
        timestamp: timestamp,
        signature: sign,
        jsApiList: this.jsApiList || []
      };
      return result;
    };

    WeixinTools.prototype.makePaySignature = function(args) {};

    return WeixinTools;

  })();

  module.exports = WeixinTools;

}).call(this);
